// DirectDrawEasy

// Hack to the original Win32 DirectDrawEasy class
// This class is designed to run the unmodified sample from the windows
// sdk. It's awful, and do not emulate all feature of DirectDrawEasy 
// but samples work.

// Method's names pretty self explanatory

// (C) 1997-98, Olivier Brunet (bruneto@efrei.fr)
//


// SMKaribou/GMF

#ifndef __DDEASY_H__
#define __DDEASY_H__

#define BYTE char
#define BOOL char
#define FALSE 0
#define TRUE 1

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>

#define MAX_COLORS   256

#define MASKS     StructureNotifyMask| ExposureMask      \
                | KeyReleaseMask | KeyPressMask          \
                | ButtonPressMask | ButtonReleaseMask    \
                | ButtonMotionMask | PointerMotionMask

class DDrawEasy {

public:      // Yeah it's dirty, but It's called DirectDrawEasy, so it should be easy !
	int win;						// Window to which is attachd the DDraw oject
	unsigned RedMask,GreenMask,BlueMask,AlphaMask;	
	unsigned Pitch;
	BOOL Ownwindow;
	BOOL Fullscreen,OwnWindow;	
	unsigned Width,Height,Depth;
	
	GC gc;
	Display *display;
	int Shm_Ok;	
	int screen;
	Colormap Cmap;
	int Completion_Type;
	XImage *XImg;

	unsigned long Pixels[MAX_COLORS];
	
	typedef unsigned char PIXEL;
	PIXEL **Bitmap;
	
	XShmSegmentInfo ShmInfo;

	// Methods
public:
	DDrawEasy();
	virtual ~DDrawEasy();
	int GetMaskSize(unsigned x);
	int GetMaskPos(unsigned x);
	void SetPal(char pal[256*3]);
	void Allocate_XImage(int Resx,int Resy,int depth);
	int Allocate_Shm_XImage(int Resx,int Resy,int depth);
	
	// forge a 32bit color value suitable for the fill routine
	unsigned MakeRGBAColor(unsigned char r,unsigned char g,unsigned char b,unsigned char a=255);	
	void Flip(void);
	unsigned char *Lock(void);							// Get a pointer on the back buffer
	void Unlock(void);							// Release lock on the back buffer

    // Fill buffers: 0 for backbuffer, 1 for frontbuffer
    void Fill(unsigned bufnum,unsigned top,unsigned left,unsigned bottom,unsigned right,unsigned color);

    // if win is NULL creates a window, if not convert the incoming window to a ddraw window
    // if lpguid is NULL is the default device adaptater, ie the one the desktop is displaying on
    virtual int SetMode(int *lpguid,int *win,unsigned xres,unsigned yres,unsigned depth,BOOL fullscreen);

    virtual void UnInit(void);

    // Called when the application do nothing put your code here
    virtual int OnIdle(void);
	virtual void Run(void);
	virtual void Error(char *str);
	void Print(unsigned x,unsigned y,char *str,unsigned r=255,unsigned g=255,unsigned b=255);
};

// Error codes returned by SetMode
#define DDE_ALREADYINITIALIZED                  1
#define DDE_DDCREATEFAILED						2
#define DDE_REGISTERFAILED						3
#define DDE_CREATEWINDOWFAILED                  4
#define DDE_NOVIDEOMODE							5
#define DDE_PRIMARYFAILED						6
#define DDE_BACKFAILED							7
#define DDE_GETBACKFAILED						8

#endif

